﻿function isMiniViewMode(){return ( window.innerHeight < 150 );}   
function logError(e){var str = '';for(var i in e){str += i + ': ' + e[i] + '<BR>';}log(str);}
function clearLog(){$$$('logDiv').innerHTML = '';}
function log(text){}//show('logForm'); $$$('logDiv').innerHTML += text + ' ';}
function $$$(id){return document.getElementById(id);}
function visible(id){return $$$(id).style.display != 'none';}
function hide(id){$$$(id).style.display = 'none';}
function height(id, height){$$$(id).style.height = height;}
function width(id, width){$$$(id).style.width = width;}

function show(id, showMode){$$$(id).style.display = showMode ? showMode: '';}
function showHide(id, showMode){if($$$(id).style.display == 'none'){show(id, showMode);}else{hide(id);}}
function setValue(id, val){if(! $$$(id)){alert('setValue error: ' + id);} if($$$(id).tagName == 'INPUT' || $$$(id).tagName == 'TEXTAREA'){$$$(id).value = val;} else if($$$(id).tagName == 'SELECT'){setSelectValue(id, val)} else {$$$(id).innerHTML = val;}}
function setSelectValue(id, val){
    var s = $$$(id);
    for(var i = 0; i < s.options.length; i++){
        if(s.options[i].value == val){s.selectedIndex = i;}    
    }
}

function getSelectValue(id){
    var s = $$$(id);
    return s.options[s.selectedIndex].value;
}

function getValue(id){if($$$(id).tagName == 'INPUT' || $$$(id).tagName == 'TEXTAREA'){return $$$(id).value;} else if ($$$(id).tagName == 'SELECT'){return getSelectValue(id)} else {return $$$(id).innerHTML;}}

function alertError(err, title) {
    var str = obj2str(err);
    alert(str);
}

function obj2str(obj){
    var str = '';
    for( var p in obj) {
        if(obj[p] instanceof Object){
            str += p + ": " + obj2str(obj[p]) + "\n";
        } else {        
            str += p + ": " + obj[p] + "\n";
        }
    }
    return str; 
}

/*

function setNavigationEnabled(){}
function preferenceForKey(){}
function setPreferenceForKey(){}
function Widget(){return this;}

Widget.prototype.setNavigationEnabled = setNavigationEnabled;
Widget.prototype.preferenceForKey = preferenceForKey;
Widget.prototype.setPreferenceForKey = setPreferenceForKey;

var widget = Widget();

*/

var lastShowedFormId = 'loginForm';
var homeScreenTimer = 0;
var homeScreenTimerInterval = 15000;
var inMiniView = false;

var thirdEdition = 0;

function onResize(){
    var els = getElementsByClassName('r-border-shape');
    var elW = '340px';
    if(window.innerHeight > 400){
        //$$$('buttonsForm').style.width = '340px';     
        //$$$('buttonsForm').style.height = '40px';                               
    } else {
        elW = parseInt(window.innerWidth ? window.innerWidth : 360) - 20;
        //$$$('buttonsForm').style.width = '60px';
        //$$$('buttonsForm').style.height = '340px';
    }
    
    
    if(isMiniViewMode()){
        if(visible('loginForm')){lastShowedFormId = 'loginForm';}        
        if(visible('calendarForm')){lastShowedFormId = 'calendarForm';}                
        if(visible('usersForm')){lastShowedFormId = 'usersForm';}
        if(visible('tasksListForm')){lastShowedFormId = 'tasksListForm';}
        if(visible('taskEditForm')){lastShowedFormId = 'taskEditForm';}
        if(visible('modalCalendarForm')){lastShowedFormId = 'modalCalendarForm';}
        hide('buttonsForm');
        hideAll();
        showHomeScreen();
                
        if(WIDGET_MODE){
            clearTimeout(homeScreenTimer);
            homeScreenTimer = setTimeout(homeScreenTimerFunc, homeScreenTimerInterval);
            //delayedShow
            window.setTimeout("show('homeForm')", 200);
            //show('homeForm');
        }        
        inMiniView = true;
    } else { // !! ! isMiniViewMode()        
        //hide('homeForm');
        window.setTimeout("hide('homeForm')", 200);
        if(lastShowedFormId == 'tasksListForm' && WIDGET_MODE){
            showButtonsForm();
        }
        if(! SID){lastShowedFormId = 'loginForm';}
        if(inMiniView && lastShowedFormId){
            if(lastShowedFormId == 'tasksListForm'){
                showDateTasks(d2str(selectedDate));
            }
            window.setTimeout("show('" + lastShowedFormId + "');", 100);
        }
        inMiniView = false;
    }

    if(WIDGET_MODE){
        $$$('buttonsForm').style.width = elW;
        for(var i = 0; i < els.length; i++){    
            els[i].style.width = elW; 
        }
        
    } else {
        var winWidth = document.body && document.body.clientWidth ? document.body.clientWidth: window.innerWidth - 10;
        winWidth -= 200;
        
        var tasksListFormWidth = parseInt(winWidth) - 220 * 2 - 20 * 3;        
        tasksListFormWidth += 'px';
        width("tasksListForm", tasksListFormWidth);    
        width("taskEditForm", tasksListFormWidth);    
        width("modalCalendarForm", tasksListFormWidth);    
        width('userParamsForm', tasksListFormWidth);
        width('userSettingsForm', tasksListFormWidth);
        width('userPasswordForm', tasksListFormWidth);
        
        
        width("calendarForm", '220px');    
        width("usersForm", '220px');    
        height("calendarDiv", '250px');    
    
        if(SID){
            show("usersForm");    
            show("calendarForm");    
        }
    }
    


}
function menuEventHandler(id){
    switch (id){
        case 11:
            logout();
            break;  
        case 12:
            showUserSettings();
            break;  
        case 13:
            createTask(UID); 
            break;
        case 14:
            rotateScreen();
            break;  
        case 15:
            showUsers();
            break;
        case 16:
            try{
                showCalendar();
            } catch(e){
                alertError(e);
            }
            break;
        case 17:
            updateTasks();
            break;
        
    }
}

function logout(){
    if(confirm(getLabel('wantsendsession'))){
        hideAll();
        startLodingAnim();
        engineLogout();
    }
}

function afterLogout(){
    loadedDatesList = new Array();
    tasksDatesList = new Array();
    tasksHash = new Array();
    tasks = new Array();
    homeScreenTasks = new Array();
    stopLodingAnim();
    selectedDate = new Date();  
    SID = 0;
    hideAll('');
    hide('buttonsForm');
    setupLoginForm();
    hide('loginFormUserCodeDiv');    
    window.setTimeout("show('loginForm');", 200);    
    setValue('homeScreenDiv', getLabel('needslogintoservice')); 
    
    clearTimeout(homeScreenTimer);
    if(! WIDGET_MODE){
        document.location.href = 'http://www.kupihleba.ru';
    } else{
        enableWidgetMenu(true);
    }

}

function showButtonsForm(){
    if(! thirdEdition){
        show('buttonsForm');
    }    
}

function setCalendarSize(){
    if(WIDGET_MODE && thirdEdition){           
        calendarTableTDwidth = '25px'; 
        calendarTableTDheight = '25px'; 
        //calendarTopTRheight = '30px';
    } 
    if(! WIDGET_MODE ){
        calendarTableTDwidth = '25px'; 
        calendarTableTDheight = '25px';         
    }

}

function createMenu(){
    var logoutMenuItem = new MenuItem(getLabel('endsession'), 11);
    logoutMenuItem.onSelect = menuEventHandler;

    var settingsMenuItem = new MenuItem(getLabel('uppersettings'), 12);
    settingsMenuItem.onSelect = menuEventHandler;
        
    var optionsMenu = window.menu;  
    optionsMenu.append(settingsMenuItem);
    optionsMenu.append(logoutMenuItem);
    if(thirdEdition){
        if (window.widget.isrotationsupported) {
            var rotateMenuItem = new MenuItem(getLabel('rotatescreen'), 14);
            rotateMenuItem.onSelect = menuEventHandler;    
            optionsMenu.append(rotateMenuItem);
        }
        
        
        var addtaskMenuItem = new MenuItem(getLabel('addtask'), 13);
        var contactsMenuItem = new MenuItem(getLabel('contacts'), 15);
        var calendarMenuItem = new MenuItem(getLabel('calendar'), 16);
        var refreshMenuItem = new MenuItem(getLabel('refresh'), 17);        
        
        addtaskMenuItem.onSelect = menuEventHandler;
        contactsMenuItem.onSelect = menuEventHandler;    
        calendarMenuItem.onSelect = menuEventHandler;    
        refreshMenuItem.onSelect = menuEventHandler;    
        
        optionsMenu.append(addtaskMenuItem);
        optionsMenu.append(contactsMenuItem);
        optionsMenu.append(calendarMenuItem);
        optionsMenu.append(refreshMenuItem);                              
    } 
    enableWidgetMenu(true);
}

var rotated = window.innerWidth == 320;

function rotateScreen(){
    if(rotated){
        changeToPortrait();
        rotated = false;
    } else {
        changeToLandscape();        
        rotated = true;
    }
}   

function changeToLandscape() {
    if (window.widget.isrotationsupported) {
        window.widget.setDisplayLandscape();
    }
}
 
function changeToPortrait(){
    if (window.widget.isrotationsupported) {
        window.widget.setDisplayPortrait();
    }
}

function enableWidgetMenu(flag){
    window.menu.getMenuItemById(11).setDimmed(flag);
    window.menu.getMenuItemById(12).setDimmed(flag);
    if(thirdEdition){
        window.menu.getMenuItemById(13).setDimmed(flag);
        window.menu.getMenuItemById(15).setDimmed(flag);
        window.menu.getMenuItemById(16).setDimmed(flag);
        window.menu.getMenuItemById(17).setDimmed(flag);
    }

}

function goToBackgroundByTimer(){    
    window.setTimeout("goToBackground();", 200);
}

function goToBackground(){
    widget.openApplication(0x102750F0, "");
}

function getPhoneModel(){
    var criteria = new Object();
    criteria.Entity = "Device";
    criteria.Key = "PhoneModel";
    try {        
        var systemServiceObj = device.getServiceObject("Service.SysInfo", "ISysInfo");
        var result = systemServiceObj.ISysInfo.GetInfo(criteria);   
        return result.ReturnValue.StringData;
    } catch (e) {
        //alert(e);
        return 0 ;
    } 
}

function init(){
    
        if(! WIDGET_MODE){    
            
            //document.styleSheets[0].insertRule(".r-border-shape", "margin: 10px 0px 10px 10px;");
            //document.styleSheets[0].addRule(".r-border-shape .r-border-shape TD", "font-size: 12px;");
            //document.styleSheets[0].addRule(".calendarTable TD", "width: 25px; height: 25px; text-align: center;");
            //document.styleSheets[0].addRule(".calendarTopTR TD, .weekDatesTR TD", "height: 30px;");
            //document.styleSheets[0].addRule("TEXTAREA, INPUT, SELECT", "padding: 0px;");
        } else {
            if(window.widget){                
                var model = getPhoneModel();
                if(model.indexOf('N97') > -1){} else {
                    window.menu.setRightSoftkeyLabel(getLabel('hidewidget'), goToBackgroundByTimer);
                }
            }
        }    
        
    
    try{
        if(WIDGET_MODE && (window.innerWidth == 240 || window.innerHeight == 240)){
            thirdEdition = 1;        
        }
        onResize();
        setupLabels();
        if(window.widget)
            widget.setNavigationEnabled( false );
        onResize();
        
        
        
        setupLoginForm();
        //createMenu();        
        //hideCalendar();
        setCalendarSize();
        showTaskCalendar(d2str(selectedDate));
        setModalCalendar(d2str(selectedDate));
        
        
        hide('buttonsForm');
        hideAll();
        if(window.menu){
            createMenu();
        }
           
        IMEI = getIMEI();
        setTimeout("show('loginForm'); onResize();", 500);

        if(! WIDGET_MODE){
            var query_str = self.location.search;
            var l = query_str.length;
            query_str = query_str.substr(1, l - 1);
            var query_str_arr = query_str.split('&');
            var obj = new Object();
            for(var i = 0; i < query_str_arr.length; i++){
                var v = query_str_arr[i].split('=');
                obj[v[0]] = v[1];
            }
            SID = obj['sid'];
            hideAll();
            hide('calendarForm');
            hide('usersForm');                        
            startLodingAnim();
            engineLoadAll();
        }
        
        //
    } catch(e){
        //alertError(e, 'init');
    }
}




//-------------------------------------------------------------------------------------

function haveTasksOnDateClbk(d){
    return tasksDatesList[d2str(d)] == 1 ? true: false;
}

function changeCalendarMonthYear(dstr, delta){
    if(isNaN(delta)){
        showTaskCalendar(dstr)
    } else {
        showTaskCalendar(dstr);
        getMonthTasks(dstr);
    }

}

function selectDateOnCalendar(dstr){
    hideAll();
    if(WIDGET_MODE){
        window.setTimeout("showButtonsForm();", 200);    
    } else {
        showNotWidgetModeForms();
    }
    if(loadedDatesList[dstr] == 1){
        showDateTasks(dstr);
    } else {
        startLodingAnim();
        getDayTasks(dstr);
    }
    selectedDate = str2d(dstr);
    window.setTimeout("show('tasksListForm')", 200);    
}

function showTaskCalendar(dstr){
    try{
        selectedDate = str2d(dstr);
        $$$("calendarDiv").innerHTML = create_calendar_html(dstr, "changeCalendarMonthYear", "selectDateOnCalendar", haveTasksOnDateClbk);
    } catch(e){
        logError(e);
    }
}

//-------------------------------------------------------------------------------


function updateUI(id, params){
    switch (id){
        case LOGIN_OK:
            stopLodingAnim();
            afterLogin(params);
            break;
        case LOGIN_ERROR:
            stopLodingAnim();
            setLoginCaptcha(params['code']);            
            if(! WIDGET_MODE){
                hide('calendarForm');
                hide('usersForm');
            }                                
            break;
        
        case SHOW_DATE_TASKS:            
            stopLodingAnim();
            showDateTasks(params);
            if(WIDGET_MODE){
                show("buttonsForm");
            }            
            window.setTimeout("show('tasksListForm')", 200);    
            break;
        
        case SHOW_DATE_TASKS_ERROR:
            alertError(params);
            alert(getLabel('saveerror'));
            show("taskEditForm");
            //show("tasksListForm");
            stopLodingAnim();
            break;
        case TASK_SAVED:

            break;
        case TASK_NEW:
            createTask(params);
            break;
        
        case MESSAGE_NEW:

            break;    
        case MESSAGE_SAVED:

            break;
            
        case NEW_PASSWORD_CODE:
            stopLodingAnim();
            changePassword(params['code']);
            break;            
        case NEW_PASSWORD_CODE_ERROR:
            stopLodingAnim();
            changePassword(params['code']);            
            break;
        case REGISTER_NEW_USER:
            stopLodingAnim();
            showRegisterUserForm(params['code']);
            break;
        case REGISTER_ERROR:            
            stopLodingAnim();
            showRegisterUserForm(params['code']);

            break;
        case REGISTER_USER:
            stopLodingAnim();
            alert(getLabel('userregistred'));
            hideAll('');
            show('loginForm');
            break;
        case FIND_USER:
            stopLodingAnim();        
            showFindUser(params);

            break;
        case FIND_USER_ERROR:
            stopLodingAnim();    
            showFindUser(params);
            break;
            
        case AUTH_USER_REQ:
            stopLodingAnim();
            setUpUsers(params);
            setValue("usersFormFindUserName", '');
            hideAll();
            window.setTimeout("show('usersForm')", 200);    
            break;
            
        case DECLINE_USER:
            stopLodingAnim();
            declineUserFinish(params);
            break;
            
        case DECLINE_USER_ERROR:
            stopLodingAnim();
            declineUserFinish(params);
            break;
            
        case ACCEPT_USER:
            stopLodingAnim();
            acceptUserFinish(params);
            break;
            
        case ACCEPT_USER_ERROR:            
            stopLodingAnim();
            acceptUserFinish(params);
            break;
        case ACCEPT_USER2:
            stopLodingAnim();
            acceptUserFinish2(params);
            break;
        case ACCEPT_USER_ERROR2:
            stopLodingAnim();
            //alertError(params);
            acceptUserFinish2(params);
            break;
        case DELETE_TASK:
            stopLodingAnim();
            showDateTasks(d2str(selectedDate));
            break;
        case DELETE_TASK_ERROR:
            stopLodingAnim();
            break;
        case UPDATE_DATA:
            stopLodingAnim();
            showUpdateTasks(params);
            break;
        case UPDATE_DATA_ERROR:
            stopLodingAnim();
            logError(params);            
            break;
        case GET_TASKS_ON_BACK:
            if(WIDGET_MODE){
                showHomeScreen();
            } else {
                showDateTasks(d2str(selectedDate));
            }                        
            break;
        case UPDATE_TIMER:
            homeScreenTimer = setTimeout(homeScreenTimerFunc, homeScreenTimerInterval);            
            break;
        case GET_TASKS_ON_BACK_ERROR:
            
            homeScreenTimer = setTimeout(homeScreenTimerFunc, homeScreenTimerInterval);        
            break;
        case PERFORM_TASK:    
            $$$('performTaskCB_' + params['result']['nid']).checked = parseInt(params['result']['performed']) ? true: false;
            $$$('performTaskCB_' + params['result']['nid']).title = parseInt(params['result']['performed']) ? getLabel('performedtask'): getLabel('performtask');
            $$$('performTaskCB_' + params['result']['nid']).disabled = false;            
            tasksHash[parseInt(params['result']['nid'])].performed = parseInt(params['result']['performed'])
            break;
        case LOGOUT:
            afterLogout();
            break;
        case LOGOUT_ERROR:
            
            break;

    }       
}

function showNotWidgetModeForms(){
    window.setTimeout("show('calendarForm'); show('usersForm');", 200); 
}

function showUserSettings(){
    hideAll();
    if(! WIDGET_MODE){
        showNotWidgetModeForms();
    } else {
        showButtonsForm();
    }
    window.setTimeout("show('userSettingsForm');", 200); 

} 

function afterLogin(params){
    selectedDate = new Date();
    showTaskCalendar(d2str(selectedDate));
    showDateTasks(d2str(selectedDate));
    show('tasksListForm');
    if(WIDGET_MODE){
        showButtonsForm();
        enableWidgetMenu(false);
    } else {
        showNotWidgetModeForms();
        
        var logoutHtml = '<b>' + users[UID].name + '</b><BR><BR>';
        logoutHtml += '<a href="#" onclick="showUserSettings(); return false;">' + getLabel('settings') + '</a>';
        logoutHtml += '&nbsp;&nbsp;&nbsp;';
        logoutHtml += '<a href="#" onclick="logout(); return false;">' + getLabel('logout') + '</a>';
        setValue('logoutDiv', logoutHtml);
        clearTimeout(homeScreenTimer);
        homeScreenTimer = setTimeout(homeScreenTimerFunc, homeScreenTimerInterval);

    }
    hide('loginForm');
    if(params['need_update'] == '1'){
        var last_version = params['last_version'];
        if(confirm(getLabel('needupdatewidget'))){            
            if(window.widget){
                widget.openURL(URLSTART + last_version);
            }
        }
    }            
}


function showPrevDateTaskList(){
    selectedDate.setDate(selectedDate.getDate() - 1);
    selectDateOnCalendar(d2str(selectedDate));
}

function showNextDateTaskList(){
    selectedDate.setDate(selectedDate.getDate() + 1);
    selectDateOnCalendar(d2str(selectedDate));
}


function showDateTasks(dstr){ 
    var tasks = getTasksOnDate(str2d(dstr));
    var headerHTML = getLabel('tasksat') + ' ' + hd2str(str2d(dstr));
    setValue('tasksListHeaderDiv', headerHTML);
    
    var html = '';
    var day_tasks_counter = 0;
    for(var i = 0; i < tasks.length; i++){
        var t = tasks[i];        
        if(t.is_deleted){
            continue;
        }
        day_tasks_counter++;
        
        
        
        var taskDatesHtml = '';
        var fromTaskHtml = '&nbsp;&nbsp;';
        if(t.puid != UID){
            fromTaskHtml += '<span style="color: #7ab800;">' + getLabel('from2') + '&nbsp;' + users[t.puid]['name'] + '</span>&nbsp;';
        } 
        if(t.uid != UID && t.puid == UID){
            fromTaskHtml += '<span style="color: #7ab800;">' + getLabel('for') + '&nbsp;' + users[t.uid]['name'] + '</span>&nbsp;';
        }        
        
        if(t.start_time.split(' ')[0] != t.end_time.split(' ')[0]){
            taskDatesHtml += '<span style="display:block; color: #7ab800; margin: 0px 0px 5px 0px; font-size: 11px;">' + sh_dt2str(mysqlstr2d(t.start_time)) + ' - ' + sh_dt2str(mysqlstr2d(t.end_time)) + '</span>';
            
        }
        
        html += '<table border="0px" cellpadding="0px" cellspacing="0px" width="100%">';
        
        html += '<tr>';
        html += '<td>';
     
        html += taskDatesHtml;
        
        if(t.comment != ''){
            html += '<a href="#" style="color: black;" ';
            html += 'onclick="showHide(\'taskCommentDiv_' + t.nid + '\', \'inline-block\'); return false;"';
            html += '>';
            html += (t.dis_message ? t.dis_message: t.message);            
            html += '</a>';
        } else {
            html += (t.dis_message ? t.dis_message: t.message);                    
        }
        html += ' ' + fromTaskHtml;           
        html += '</div>';               
        html += '</td>'; 
        
        html += '<td width="20px" align="right" valign="top">';
        html += '   <input type="checkbox" id="performTaskCB_' + t.nid + '" onclick="performTask(' + t.nid + ');" ' + (t.performed ? 'checked': '') + '>';
        html += '</td>'; 
        html += '</tr>'; 

        if(t.comment != ''){
            html += '<tr id="taskCommentDiv_' + t.nid + '" style="display: none;">';
            html += '<td></td>';
            html += '<td><div class="sub_task_comment">';
            html += (t.dis_comment ? t.dis_comment: t.comment);            
            html += '</div></td>';
            html += '<td></td></tr>';
            html += '<tr><td colspan="2" height="5px"></td></tr>';            
        }
        
        for(var j = 0; j < t.subTasks.length; j++){
            var st = t.subTasks[j];
            day_tasks_counter++;
          
            html += '<tr><td>';
            html += '<div class="sub_task_message">';
            if(st.comment != ''){                
                html += '<a href="#" style="color: black;" ';
                html += 'onclick="showHide(\'taskCommentDiv_' + st.nid + '\', \'inline-block\'); return false;"';
                html += '>';
                html += (st.dis_message ? st.dis_message: st.message);                    
                html += '</a>';                   
            } else {
                html += (st.dis_message ? st.dis_message: st.message);                    
            }
            html += '</div>';
            html += '</td>'; 
             
            html += '<td width="20px" align="right" valign="top">';
            html += '   <input type="checkbox" id="performTaskCB_' + st.nid + '" onclick="performTask(' + st.nid + ');" ' + (st.performed ? 'checked': '') + '>';
            html += '</td>'; 
            html += '</tr>'; 
            
            if(st.comment != ''){
                html += '<tr id="taskCommentDiv_' + st.nid + '" style="display: none;">';
                html += '<td></td>';
                html += '<td><div class="sub_task_comment">';
                html += (st.dis_comment ? st.dis_comment: st.comment);                    
                html += '</div></td>';
                html += '<td></td></tr>';
                html += '<tr><td colspan="2" height="5px"></td></tr>';
            }

        }        
        
        html += '<tr><td>';
        html += '<div id="taskListEditButtons_' + t.nid + '" style="width: 100%; display: ; right; margin: 5px 0px 10px 0px;">';
        html += '   <div style="display: inline-block; text-align: left; float: left; margin: 0px 10px 0px 0px;">';
        html += '       <a href="#" class="mlabel" onclick="editTask(' + t.nid + '); return false;" id="editTaskButton_' + t.nid + '" style="margin: 10px 0px 10px 0px;">' + getLabel('edit') + '</a>';
        html += '   </div>';
        html += '   <div style="width: 40%; display: inline-block; text-align: left;">';
        html += '       <a href="#" class="mlabel" onclick="deleteTask(' + t.nid + '); return false;" id="editTaskButton_' + t.nid + '" style="margin: 10px 0px 10px 0px;">' + getLabel('delete') + '</a>';
        html += '   </div>';        
        html += '</div>';   
        html += '</td><td></td></tr>';
        
        html += '<tr><td colspan="2" height="10px"></td></tr>';
        
        
        html += '</table>';                
    }
    
    $$$('tasksListDiv').innerHTML = html;
    $$$('tasksListFormAddEditButtonsDiv').style.display = day_tasks_counter > 10? 'block' :'none';
    $$$('tasksListFormAddEditButtonsDiv').style.width = '90%'; 
}   

function showCalendar(){
    hideAll();
    if(WIDGET_MODE){
        window.setTimeout("showButtonsForm()", 200);        
    }
    showTaskCalendar(d2str(selectedDate));
    window.setTimeout("show('calendarForm')", 200);    
}

function showUsers(){
    hideAll();
    if(WIDGET_MODE){
        window.setTimeout("showButtonsForm()", 200);        
    }    
    window.setTimeout("show('usersForm')", 200);
}


function cancelSaveTask(){
    setView(SHOW_TASKS);
}                        

function trySaveTask(){
    var sd      = mysqlstr2d(getValue('taskEditStartDate'));
    var ed      = mysqlstr2d(getValue('taskEditEndDate'));

    
    if(sd > ed){
        alert(getLabel('error') + ': ' + getLabel('startdategtenddate') + '!');
        return;
    }   
    startLodingAnim(); 
    saveTask();

}


function hideAll(){
    hide('updateLogForm');
    hide('calendarForm');
    hide('tasksListForm');
    hide('taskEditForm');
    hide('usersForm');
    hide('acceptUserForm');    
    hide('modalCalendarForm');
    hide('logForm');
    hide('loginForm');
    hide('registerUserForm');
    hide('addUserForm');
    hide('homeForm');
    hide('buttonsForm');
    hide('changeLoginForm');
    hide('userParamsForm');
    hide('userSettingsForm');
    hide('userPasswordForm');
}    

function setUpUser(data){
    UID = data['user']['uid'];
    users[UID] = {'puid': UID, 'name': data['user']['name'], 'email': data['user']['email']};
}


function setUpUsers(data){
        var uu = data['users']['user_users'];
        var html = '';       
        var s = $$$('taskEditFormUserSelect');
        s.options.length = 0;
        s.options[s.options.length] = new Option(getLabel('yourself'), UID);                
        for (var i = 0; i < uu.length; i++){
            var u = new User(uu[i]);
            users[u.puid] = u;
            if(u.puid != UID){    
                html += createUserLineHTML(u);
                s.options[s.options.length] = new Option(u.name, u.puid);                
            }
        }
        
        $$$("user_users_form").innerHTML = html;

        auth_user_users = data['users']['auth_user_users'];
        if(auth_user_users.length > 0){
            var html = '';
            html += '<div style="display: block; margin: 20px 0px 10px 0px;">' + getLabel('thisuserswantstoaddyoutocontactlist') + '</div>';
            for(var i = 0; i < auth_user_users.length; i++){
                var uu = new User(auth_user_users[i]);
                html += '<div style="width: 50%; display: inline-block; float: left;">';
                html += uu.name;
                html += '</div>';
                html += '<div style="width: 25%; display: inline-block; float: left;">';
                html += '<a href="#" onclick="acceptUser(' + uu.puid + '); return false;">' + getLabel('accept') + '</a>';
                html += '</div>';
                html += '<div style="width: 25%; display: inline-block; float: left;">';
                html += '<a href="#" onclick="declineUser(' + uu.puid + '); return false;">' + getLabel('decline') + '</a>';
                html += '</div>';
            }
            $$$("auth_user_users_form").innerHTML = html;
        } else {
            $$$("auth_user_users_form").innerHTML = '';
        }
        
        html = '';
        wait_user_users = data['users']['wait_user_users'];
        if(wait_user_users.length > 0 ){            
            var declined = new Array;
            var flag = 0;
            for(var i = 0; i < wait_user_users.length; i++){
                var uu = new User(wait_user_users[i]);
                if(uu.authed > -1){    
                    html += uu.name;                                  
                    html += '<br>';
                    flag = 1;
                } else if(uu.authed == -1){    
                    declined.push(uu);
                }                
            }
            if(flag){
                html = '<div style="display: block; margin: 20px 0px 10px 0px;">'  + getLabel('waitingauthreq') + '</div>' + html; 
            }            
            if(declined.length > 0){
                html += '<br>';
            }
            for(var i = 0; i < declined.length; i++){            
                html += declined[i].name;
                html += '&nbsp;';
                html += getLabel('userdeclinedyou');
                html += '&nbsp;&nbsp;';
                html += '<a href="#" onclick="hideDeclineUser(' + declined[i].uid + '); return false;">' + getLabel('hide') + '</a><br>';                
                html += '<br>';
            }
            
            $$$("wait_user_users_form").innerHTML = html;
        } else {
            $$$("wait_user_users_form").innerHTML = '';
        }


    }


//----------------------------------------------------------------


    function User(data){
        this.uid             = parseInt(data['uid']);
        this.puid             = parseInt(data['puid']);
        this.authed           = parseInt(data['authed']);        
        this.can_have_message = parseInt(data['can_have_message']);
        this.can_have_note    = parseInt(data['can_have_note']);
        this.can_send_message = parseInt(data['can_send_message']);
        this.can_add_note     = parseInt(data['can_add_note']);
        this.name = data['name'];
        return this;
    }
    
    function createUserLineHTML(u){
        var html = '';
        html += '<div id="userDiv_' + u.puid + '" style="display: inline-block; width: 100%; margin: 10px 0px 10px 0px;">';
        html += '<div onclick="selectUser(' + u.puid + ');" style="display: inline-block; width: 90%; float: left;">';
        html += '<b>' + u.name + '</b>';
        html += '</div>';
        
        if(u.can_add_note > 0){
            html += '<div style="display: inline-block; width: 100%; float: left; text-align: right;">';
            html += '<a href="#" onclick="updateUI(TASK_NEW, ' + u.puid + '); return false;"  class="mlabel">' + getLabel('addtask') + '</a>';
            html += '</div>';
        }
        
        html += '</div>';
        return html;
    }
    
    
    function selectUser(uid){
    
    }
    
    
//-----------------------------------------------------------------

var modalCalendarTargetEl = 0;
var modalCalendarTargetDivId = 0;
var modalCalendarTargetClbk = 0;

function showModalCalendarForElement(el, divId, clbk){
    if(divId){
        modalCalendarTargetDivId = divId;
        hide(modalCalendarTargetDivId);
    }
    var dstr = getValue(el.id);
    modalCalendarTargetEl = el;
    modalCalendarTargetClbk = clbk;
    showModalCalendar(dstr);
}

function showHideTaskButtons(){
    var els = getElementsByClassName('taskListButtons');
    for(var i = 0; i < els.length; i++){
        els[i].style.display = els[i].style.display != 'inline-block'? 'inline-block': 'none';
    }
}

function cancelChangeUserParams(){
    showUserSettings();
}

function tryChangeUserParams(){
    var des_user_name = getValue('userParamsFormDesUserName');
    var user_email = getValue('userParamsFormEmail');
    startLodingAnim(); 
    engineChangeUserParams(des_user_name, user_email);
}


function showModalCalendar(dstr){
    //hideAll('');
    show('modalCalendarForm');
    if(dstr == ''){dstr = dt2mysqlstr(new Date());}
    var re = /^(\d{4})-(\d{2})-(\d{2}) (\d{2}):(\d{2}):(\d{2})$/;
    var date = re.exec(dstr);
    var flag = false;
    var minuteStep = 5;
    if (date) {     
        setModalCalendar(date[3] + '-' + date[2] + '-' + date[1]);        
        $$$('modalCalendarFormHours').value = date[4];
        $$$('modalCalendarFormMinutes').value = Math.floor(parseInt(date[5], 10) / minuteStep) * minuteStep;
        flag = true;
    }
    if(! flag){
        var re = /^(\d{2})-(\d{2})-(\d{4}) (\d{2}):(\d{2}):(\d{2})$/;
        var date = re.exec(dstr);
        var flag = false;
        if (date) {     
            setModalCalendar(date[1] + '-' + date[2] + '-' + date[3]);        
            $$$('modalCalendarFormHours').value = date[4];
            $$$('modalCalendarFormMinutes').value = Math.floor(parseInt(date[5], 10) / minuteStep) * minuteStep;
            flag = true;
        }        
    }
    if(! flag){
        alert(getLabel('wrongdateformat') + ': ' + dstr + '!');
    }
}

var modalSelectedDstr;
function haveTasksOnDateModalClbk(d){
   return modalSelectedDstr == d2str(d)? true: false;
}

function selectDateOnModalCalendar(dstr){
    modalSelectedDstr = dstr;
    $$$('modalCalendarFormDate').innerHTML = dstr;
    $$$("modalCalendarDiv").innerHTML = create_calendar_html(dstr, "setModalCalendar", "selectDateOnModalCalendar", haveTasksOnDateModalClbk, "mdlClndr");
    
}

function setModalCalendar(dstr){
    try{
        //selectedDate = str2d(dstr);
        modalSelectedDstr = dstr;
        $$$("modalCalendarDiv").innerHTML = create_calendar_html(dstr, "setModalCalendar", "selectDateOnModalCalendar", haveTasksOnDateModalClbk, "mdlClndr");
        $$$('modalCalendarFormDate').innerHTML = dstr;
    } catch(e){
        logError(e);
    }
}    

function modalCalendarCancel(){
    hide('modalCalendarForm');
    if(modalCalendarTargetDivId){
       show(modalCalendarTargetDivId);
    }    
}

function modalCalendarOK(){
    var dstr = $$$('modalCalendarFormDate').innerHTML; 
    var h = $$$('modalCalendarFormHours').value;
    var m = $$$('modalCalendarFormMinutes').value;
    dstr += ' ' + h + ':' + m + ':00';
    setValue(modalCalendarTargetEl.id, dstr);
    hide('modalCalendarForm');
    if(modalCalendarTargetDivId){
       show(modalCalendarTargetDivId);
    }
    if(modalCalendarTargetClbk){
        modalCalendarTargetClbk();
    }
}

function online(){
    setMessageTimer();    
}

function setupLoginForm(){
    loadSettings(); 
    setValue('loginFormLogin', LOGIN);
    $$$('loginFormSavePassword').checked = SAVE_PASSWORD == 1 ? true: false;
    
    //$$$('loginFormEnterAutomatically').checked = ENTER_AUTOMATICALLY == 1 ? true: false;            
    if(parseInt(SAVE_PASSWORD) > 0){    
        setValue('loginFormPassword', PASSWORD);
        if(0 && ENTER_AUTOMATICALLY == 1){
            hideAll();
            login();
        }
    }
}    

function login(){    
    hideAll();
    
    var login = getValue('loginFormLogin');
    var passwd = getValue('loginFormPassword');
    
    
    
    SAVE_PASSWORD = $$$('loginFormSavePassword').checked == true? 1: 0;
    //ENTER_AUTOMATICALLY = $$$('loginFormEnterAutomatically').checked == true? 1: 0;   
    LOGIN = login; 
    PASSWORD = passwd;
    
    saveSettings();     
    
    
    startLodingAnim(); 
    var code = getValue('loginFormCode');
    var user_code = getValue('loginFormUserCode');
    engineLogin(login, passwd, code, user_code);
    
}    


function cancelChangePassword(){
    showUserSettings();
}

function setUserParams(){
    
    hideAll();
    if(! WIDGET_MODE){
        showNotWidgetModeForms();
    }
    setValue('userParamsFormDesUserName', users[UID]['name']);
    setValue('userParamsFormEmail', users[UID]['email']);
    window.setTimeout("show('userParamsForm');", 200); 
    
}



function tryChangePassword(){
    //hideAll();
    if(! WIDGET_MODE){
        showNotWidgetModeForms();
    }
    var oldpassword = getValue('userPasswordFormOldPassword');
    var newpassword = getValue('userPasswordFormPassword');
    var confirmnewpassword = getValue('userPasswordFormConfirmPassword');
    var user_code = getValue('userPasswordFormUserCode');
    var code = getValue('userPasswordFormCode');
    engineChangeUserPassword(oldpassword, newpassword, confirmnewpassword, user_code, code);    
    startLodingAnim();    
}

function startChangePassword(){
    startLodingAnim(); 
    hideAll();
    engineGetNewPasswordCode(0);
}    

function changePassword(code){

    hideAll();
    if(! WIDGET_MODE){
        showNotWidgetModeForms();
    }
    var imgurl = URLSTART + '/captcha/' + code +'.png';
    setValue('userPasswordFormCode', code);        
    $$$('userPasswordFormCodeImg').src = imgurl;    

    window.setTimeout("show('userPasswordForm');", 200);     

}

function setLoginCaptcha(code){
    if(code){
        var imgUrl = URLSTART + '/captcha/' + code +'.png';
        $$$('loginFormCodeImg').src = imgUrl;
    
        setValue('loginFormUserUrl', imgUrl);
        setValue('loginFormUserCode', '');
        setValue('loginFormCode', code);
        show('loginFormUserCodeDiv');
    }
    show("loginForm");
}

function startRegisterUser(){
    hideAll(); 
    startLodingAnim();
    engineGetRegisterCode();
}    

function showRegisterUserForm(code){    
    var imgUrl = URLSTART + '/captcha/' + code +'.png';
    $$$('registerUserFormCodeImg').src = imgUrl;
    setValue('registerUserFormCode', code);
    show('registerUserForm');
}            

function registerUser(){
    var login               = getValue('registerUserFormLogin');
    var password            = getValue('registerUserFormPassword');
    var confirm_password    = getValue('registerUserFormConfirmPassword');
    var des_user_name       = getValue('registerUserFormDesUserName');
    var email               = getValue('registerUserFormEmail');
    var user_code           = getValue('registerUserFormUserCode');
    var code                = getValue('registerUserFormCode');
    
    if(password != confirm_password){
        alert(getLabel('passwordsnotequal'));
        return;
    }
    if(password == ''){
        alert(getLabel('enterpassword'));
        return;
    }
    if(login == ''){
        alert(getLabel('enterlogin'));
        return;
    }
    if(email == ''){
        alert(getLabel('enteremail'));
        return;
    }
    startLodingAnim();
    engineRegisterUser(login, password, des_user_name, email, user_code, code);                    
}

function reloadCode(inp_id, img_id){
    startLodingAnim();
    engineGetCode(inp_id, img_id);
}

function updateCapchaCode(inp_id, img_id, data, e){
    if(1){        
        stopLodingAnim();
        var imgurl = URLSTART + '/captcha/' + data['code'] +'.png';
        setValue(inp_id, data['code']);        
        $$$(img_id).src = imgurl;
    }
}

function findUser(){
    stopLodingAnim();
    var find_user = getValue("usersFormFindUserName");    
    if(find_user != ''){
        startLodingAnim();        
        engineFindUser(find_user);
    } else {
        alert(getLabel('enterusername'));
    }
}

function authUserReq(){
    var add_user_uid = getValue('addUserFormFoundUserUID');
    var can_add_note = $$$('addUserFormCanAddTask').checked == true ? 1: 0;
    var can_send_message = 1;
    startLodingAnim();
    engineAddUser(add_user_uid, can_add_note, can_send_message);
}

function showFindUser(data){
    hideAll();
    window.setTimeout("show('addUserForm')", 200);
    if(data['error']){
        show('addUserFormErrorDiv');
        hide('addUserFormSettingsDiv');
        var html = '<center>' + getLabel('error') + '!</center><br><br>';
        if(data['error_code_str']){
            html += getLabel('user') + ' <b>' + getValue("usersFormFindUserName") + (data['find_user_name'] ? (' (' + data['find_user_name'] + ') '): '') + '</b> ' + getLabel(data['error_code_str']) + '!';
        }        
        setValue('addUserFormErrorDiv', html);               
    } else {
        hide('addUserFormErrorDiv');
        show('addUserFormSettingsDiv');
        setValue('addUserFormUserName', data['find_user_name']);    
        setValue('addUserFormUserUname', data['find_user_uname']);            
        setValue('addUserFormFoundUserUID', data['find_user_uid']);    
    }           
}

function acceptUser(puid){
    startLodingAnim();
    hideAll();
    engineAcceptUser(puid);
}

function acceptUserFinish(params){   
    setValue('acceptUserFormUserName', params['accept_user']['name']);
    setValue('acceptUserFormUserUID', params['accept_user']['uid']);
    $$$('acceptUserFormAllowsAddTask').style.display = params['accept_user']['can_add_note'] == 1 ? '': 'none';
    show('acceptUserForm');
}

function declineUser(puid){
    startLodingAnim();
    hideAll();
    engineDeclineUser(puid);
}

function declineUserFinish(params){
    setUpUsers(params);
    show('usersForm');
}

function acceptUserReq(){
    var puid = getValue('acceptUserFormUserUID');
    var canaddtask = $$$('acceptUserFormCanAddTask').checked == true? 1: 0;
    hideAll();
    startLodingAnim();    
    engineAcceptUser2(puid, canaddtask);
}

function acceptUserFinish2(params){
    setUpUsers(params);
    show('usersForm');
}

function hideDeclineUser(puid){
    startLodingAnim();
    hideAll();
    engineHideDeclineUser(puid);
}
 
function deleteTask(nid){
    if(confirm(getLabel('deletetaskfromlist'))){
        startLodingAnim();
        engineDeleteNote(nid);
    }
}

function updateTasks(){
    startLodingAnim();
    engineUpdateNotesAndUsers();
}

function showUpdateTasks(params){   
    if(visible('usersForm')){
        show('usersForm');
    }
    showTaskCalendar(d2str(selectedDate));
    showDateTasks(d2str(selectedDate));
}

function showHomeScreen(){
    var html = '';
    var td = new Date();
    var today = d2str(td);
    for(var i = 0; i < homeScreenTasks.length; i++){
        var t = tasksHash[homeScreenTasks[i]];
        var st = mysqlstr2d(t.start_time);
        var et = mysqlstr2d(t.end_time);
        var sts = d2str(st);
        var ets = d2str(et);
        
        if(! t.performed && ! t.is_deleted == 1 && (st <= td && td <= et)){    
            var msg = t.message;
            if(msg.length > 33){
                msg = msg.substring(0,33) + '...';
            }
            html += msg + '<br>';             
        } 
    }
    if(SID){
        setValue('homeScreenDiv', html);
    }
}

var isOnlineUpdateCounter = 0;
function homeScreenTimerFunc(){
    if(SID && (visible('homeForm') || ! WIDGET_MODE)){
        clearTimeout(homeScreenTimer);
        if(WIDGET_MODE){
            showHomeScreen();
        }                
        if(isOnline()){
            if(isOnlineUpdateCounter == 1){
                isOnlineUpdateCounter = 0;
                getSysAjax2();
            } else {
                isOnlineUpdateCounter++;
                homeScreenTimer = setTimeout(homeScreenTimerFunc, homeScreenTimerInterval);
            }
        } else {
            isOnlineUpdateCounter = 0;
            homeScreenTimer = setTimeout(homeScreenTimerFunc, homeScreenTimerInterval);
        }
    }    
           
}


function isOnline(){
    var result = 0;
    if(! WIDGET_MODE){
        result = 1;
    }
    try{        
        var st = window.navigator.onLine;        
        if (st == 2){                        
            result = 1;
        }        
    } catch(e){
        
    }
    return result;
}