﻿

function defChangeMonthYearClbkName(stringDate){
    alert('NO defChangeMonthYearClbkName CALLBACK ' + stringDate);        
}

function defSelDateClbkName(stringDate){
    alert('NO selDateClbk CALLBACK ' + stringDate);        
}

function defHaveTasksOnDateClbk(d){
    return 0;
}

var hasTaskClasses = new Array();
hasTaskClasses[0] = '';
hasTaskClasses[1] = 'oneDayTaskTD';
hasTaskClasses[2] = 'firstDayTaskTD';
hasTaskClasses[3] = 'middleDayTaskTD';
hasTaskClasses[4] = 'lastDayTaskTD';

var jssCalendarCounter = 1;

var calendarTableTDwidth = '40px'; 
var calendarTableTDheight = '30px'; 
var calendarTopTRheight = '30px';

function create_calendar_html(stringDate, changeMonthYearClbkName, selDateClbkName, haveTasksOnDateClbk, prefix){    

    if(! changeMonthYearClbkName){changeMonthYearClbkName = 'defChangeMonthYearClbkName';}
    if(! selDateClbkName){selDateClbkName = 'defSelDateClbkName';}
    if(! haveTasksOnDateClbk){haveTasksOnDateClbk = defHaveTasksOnDateClbk;}
    if(! stringDate){stringDate = d2str(new Date());}
    if(! prefix){prefix = 'calendarDiv_' + (jssCalendarCounter++);}
    var date = str2d(stringDate);
    
    var prevYearDate = new Date(date);
    prevYearDate.setFullYear(prevYearDate.getFullYear() - 1);
    
    var nextYearDate = new Date(date);
    nextYearDate.setFullYear(nextYearDate.getFullYear() + 1);
    
    var nextMonthDate = new Date(date);
    nextMonthDate.setMonth(nextMonthDate.getMonth() + 1);
    
    var prevMonthDate = new Date(date);
    prevMonthDate.setMonth(prevMonthDate.getMonth() - 1);
    
    var html = '';
    html += '<table cellspacing="0px" class="calendarTable" align="center">';
    html += '<tr style="height: ' + calendarTableTDwidth + '" class="calendarTopTR">';
    html += '<td align="right" class="clickableTD"><a href="#"  onclick="' + changeMonthYearClbkName + '(\'' + d2str(prevYearDate) + '\', -12); return false;">&laquo;</a></td>';
    html += '<td colspan="5" align="center">' + date.getFullYear() + '</td>';
    html += '<td class="clickableTD"><a href="#" onclick="' + changeMonthYearClbkName + '(\'' + d2str(nextYearDate) + '\', 12); return false;">&raquo;</a></td>';

    html += '<tr style="height: ' + calendarTableTDwidth + '" class="calendarTopTR">';
    html += '<td class="clickableTD" align="right"><a href="#" onclick="' + changeMonthYearClbkName + '(\'' + d2str(prevMonthDate) + '\', -1); return false;">&laquo;</a></td>';
    html += '<td colspan="5" align="center">' + mLong[date.getMonth()] + '</td>';
    html += '<td class="clickableTD"><a href="#" onclick="' + changeMonthYearClbkName + '(\'' + d2str(nextMonthDate) + '\', 1); return false;">&raquo;</a></td>';

    html += '<tr class="weekDatesTR">';
    for (i = 0; i < wShort.length; i++){
        html += '<td>' + wShort[i] + '</td>';
    }

    var m = new Date(date);
    m.currentMonth = m.getMonth();    
    m.currentDate = m.getDate();

    var now = new Date();

    var n = 1;

    m.setDate(1);
    var w = m.getDay();
    w = (w == 0) ? 7 : w;
    if (w > 1){
        html += '<tr class="datesTR">';
        for (i = 1; i < w; i++){
            html += '<td>&nbsp;</td>';
            n++;
        }
    }

    var todayDate = d2str(new Date());
    for (i = 1; i <= 31; i++){
        m.setDate(i);
        if (m.getMonth() != m.currentMonth) {
            break;
        }

        if (n % 7 == 1) {
            html += '<tr class="datesTR">';
        }
                
        var dstyle = '';
        if(todayDate == d2str(m)){
            dstyle = ' style="font-weight: bold; border: 1px dotted #7ab800;"';
        }        
       
        var hasTask = haveTasksOnDateClbk(m);
        if(hasTask){            
            //html += '<td class="dateTD ' + hasTaskClasses[hasTask] + '" ';            
            html += '<td style="width: ' + calendarTableTDwidth + '; height: ' + calendarTableTDheight + ';" class="dateTD oneDayTaskTD" ' + dstyle + '>';            
        }
        else{
            html += '<td style="width: ' + calendarTableTDwidth + '; height: ' + calendarTableTDheight + ';"  class="dateTD" ' + dstyle + '>';
        }
        html += '<a href="#" onclick="' + selDateClbkName + '(\'' + d2str(m) + '\'); return false;">';
        html += i;
        html += '</a></td>';        
        
        n++;
    }

    if (n % 7 > 1){
        for (i = 0; i <= 7 - n % 7; i++){
            html += '<td>&nbsp;</td>';
        }
    }
    if (n % 7 == 0){
        html += '<td>&nbsp;</td>';
    }
    
    html += '</tr>';
    html += '</table>';
    
    return html;

}


//---------------------------------------------------------------------------------------------

function hd2str(date){    
    return  zeroFill(date.getDate()) + ' ' + mLongRod[date.getMonth()] + ' ' + date.getFullYear();
}

//------------------------------------------------------------------------------

function shd2str(date){    
    return  zeroFill(date.getDate()) + ' ' + mShort[date.getMonth()] + ' ' + date.getFullYear();
}

//------------------------------------------------------------------------------

function sh_dt2str(date){    
    return  zeroFill(date.getDate()) + ' ' + mShort[date.getMonth()] + ' ' + date.getFullYear() + ' ' + zeroFill(date.getHours()) + ':' + zeroFill(date.getMinutes());
}

//------------------------------------------------------------------------------

function d2mysqlstr(date){    
    return  date.getFullYear() + '-' + zeroFill(date.getMonth() + 1) + '-' + zeroFill(date.getDate());
}

//------------------------------------------------------------------------------

function dt2mysqlstr(date){
    return date.getFullYear() + '-' + zeroFill(date.getMonth() + 1) + '-' + zeroFill(date.getDate()) + ' ' + zeroFill(date.getHours()) + ':' + zeroFill(date.getMinutes()) + ':' + zeroFill(date.getSeconds());
}


//------------------------------------------------------------------------------

function dt2humanstr(date){
    return zeroFill(date.getDate()) + '-' + zeroFill(date.getMonth() + 1) + '-' + date.getFullYear() + ' ' + zeroFill(date.getHours()) + ':' + zeroFill(date.getMinutes()) + ':' + zeroFill(date.getSeconds());
}

//------------------------------------------------------------------------------

function mysqlstr2humanstr(str){   
    var re = /(\d+)-(\d+)-(\d+) (\d+):(\d+):(\d+)/;
    var date = re.exec(str);    
    if (date) {
    	var yearN = date[1];
    	var dayN = date[3];
    	if(yearN.length == 2){
    		yearN = date[3];
    		dayN = date[1];
    	}
        return dayN + '-' + date[2] + '-' + yearN  + ' ' + date[4]  + ':' + date[5] + ':' + date[6];
    }
    return str;
}

//------------------------------------------------------------------------------

function mysqlstr2d(str){   
    var re = /(\d+)-(\d+)-(\d+) (\d+):(\d+):(\d+)/;
    var date = re.exec(str);    
    if (date) {
    	var yearN = parseInt(date[1], 10);
    	var dayN = parseInt(date[3], 10);
    	if(date[1].length == 2){
    		yearN = parseInt(date[3], 10);
    		dayN = parseInt(date[1], 10);
    	}
        return new Date(yearN, parseInt(date[2], 10) - 1, dayN, parseInt(date[4], 10), parseInt(date[5], 10), parseInt(date[6], 10));
    }
}

//------------------------------------------------------------------------------

function d2str(date){    
    return  zeroFill(date.getDate()) + '-' + zeroFill(date.getMonth() + 1) + '-' + date.getFullYear();
}

//------------------------------------------------------------------------------

function str2d(string){
    var re = /^(\d{2})-(\d{2})-(\d{4})$/;
    var date = re.exec(string);
    if (date) {     
        return new Date((parseInt(date[3], 10)), parseInt(date[2], 10) - 1, parseInt(date[1], 10));
    }
}

//------------------------------------------------------------------------------

function string2date(string){
    var re = /(\d+)-(\d+)-(\d+)/;
    var date = re.exec(string);
    if (date) {
        return new Date(date[1], date[2] - 1, date[3]);
    }
}

//------------------------------------------------------------------------------

function zeroFill(value){
    return (value < 10 ? '0' : '') + value;
}

//------------------------------------------------------------------------------
