﻿function setSID(s){
    SID = s;
    log('SID = ' + SID + '<BR>');
}

function engineLogout(){
    try{
        var url = URLSTART + '/cgi-bin/mf_widget.cgi?sid=' + SID + '&imei=' + IMEI + '&cmd=logout&rnd=' + Math.random(1);        
        AJAXLoad(url, function(responseText, status){
            try{
                var data = eval("(" + responseText + ")");
                updateUI(LOGOUT);
            } catch(e){
                logError(e);
                updateUI(LOGOUT_ERROR, e);
            }
        });
    } catch(e){
        logError(e);
    }    
}

function engineLogin(uname, password, code, user_code){
    try{
        var login_url = URLSTART + '/cgi-bin/mf_widget.cgi?imei=' + IMEI + '&uname=' + uname + '&pass=' + password + '&cmd=login&version=' + VERSION + '&rnd=' + Math.random(1);
        if(user_code != ''){
            login_url += '&code=' + code + '&user_code=' + user_code;
        }
        
        AJAXLoad(login_url, function(responseText, status){
            try{
                loadedDatesList[d2str(selectedDate)] = 1;
                engineAfterLogin(responseText, status);       
                
            } catch(e){
                alertError(e);
                updateUI(LOGIN_ERROR);
            }
        });
    } catch(e){
        logError(e);
    }    
}

function engineLoadAll(){
    try{
        var login_url = URLSTART + '/cgi-bin/mf_widget.cgi?sid=' + SID + '&cmd=load_all&rnd=' + Math.random(1);
        loadedDatesList[d2str(selectedDate)] = 1;
        AJAXLoad(login_url, function(responseText, status){
            try{
                engineAfterLogin(responseText, status);       
            } catch(e){
                alertError(e);
                updateUI(LOGIN_ERROR);
            }
        });
    } catch(e){
        alertError(e);
    }    
}

function engineAfterLogin(responseText, status){
    var data = eval("(" + responseText + ")");
    //alert(responseText);
    if(data['error']){
        //alertError('ERROR: ' + data['error']);                                
        SID = 0;
        if(data['error'] == -3){
            alert(getLabel('wrongpasswordorusername'));
        } else if(data['error'] == -4){
            alert(getLabel('entercode'));
        } else if(data['error'] == -5){
            alert(getLabel('wrongusercode'));
        }
        updateUI(LOGIN_ERROR, data);
    } else {
        if(data['last_write_mid']){
            last_write_mid = data['last_write_mid'];}
        if(data['sid']){
            setSID(data['sid']);}
        if(data['user']){
            setUpUser(data);}    
        if(data['users']){
            setUpUsers(data);}
        if(data['tasks']){
            setTasks(data);}
        if(data['tasks_list']){
            setTasksDates(data);}
        
        updateUI(LOGIN_OK, data);
    }

}


function getSys(){
    try{
        var login_url = URLSTART + '/cgi-bin/mf_widget.cgi?sid=' + SID + '&rnd=' + Math.random(1);
        AJAXLoad(login_url, function(responseText, status){
            try{
                var data = eval("(" + responseText + ")");
                clearLog();
                if(data['last_write_mid']){
                    log(data['last_write_mid']);
                } else {
                    log(responseText);
                }
            } catch(e){
    
            }
        });
    } catch(e){
        log('ERROR');
    }

}


function sendAjaxMessage(){
    var msg = $$$("messagesFormMessage").value;
    var current_user_id = $$$("messagesFormPUID").value;
    if (msg == ''){return;}

    var url = URLSTART + "/cgi-bin/mf.cgi";
    var params = "cmd=send_message&param1=" + current_user_id;
        params += "&message=" + msg;
        params += "&json=1";
        params += "&sid=" + SID;
        params += "&rnd=" + Math.random(1);
        msg.value = '';

    AJAXPOSTLoad(url, params, function(responseText, status){
        try{
            var data = eval("(" + responseText + ")");
            log(responseText);
        } catch(e){
            //var errorstr = responseText + '\nERROR:\n';for (i in e){errorstr += i + ': ' + e[i] + '\n';} alert(errorstr);
        };
    });
}

function getDayTasks(dstr){
    var url = URLSTART + "/cgi-bin/mf.cgi?cmd=day_tasks_list&tasks_date=" + dstr + "&sid=" + SID + "&rnd=" + Math.random(1);
    loadedDatesList[dstr] = 1;
    AJAXLoad(url, function(responseText, status){
        try{        
            var data = eval("(" + responseText + ")");
            setTasks(data);
            updateUI(SHOW_DATE_TASKS, dstr);
        } catch(e){
            updateUI(SHOW_DATE_TASKS_ERROR, e);
        }
    });
}

function getMonthTasks(dstr){
    var url = URLSTART + "/cgi-bin/mf.cgi?cmd=month_tasks_list&tasks_date=" + dstr + "&sid=" + SID + "&rnd=" + Math.random(1);
    var temp_selectedDate = dstr;
    AJAXLoad(url, function(responseText, status){
        try{            
            var data = eval("(" + responseText + ")");
            if(data['tasks_list']){
                setTasksDates(data);}                    
            showTaskCalendar(dstr);
        } catch(e){
            logError(e);
        }
    });
}

function performTask(nid){
    var url = URLSTART + "/cgi-bin/mf.cgi?cmd=performe_task&param1=" + nid + "&sid=" + SID + "&rnd=" + Math.random(1);
    
    //$$$('performTaskCB_' + nid).checked = $$$('performTaskCB_' + nid).checked == true ? false : true;
    $$$('performTaskCB_' + nid).disabled = true;
    AJAXLoad(url, function(responseText, status){
        try{
            var data = eval("(" + responseText + ")");
            //alert(responseText);
            updateUI(PERFORM_TASK, data);            
        } catch(e){}
    });
}


function parseCRLF(text){    
    return text.split('\n').join('%0D%0A'); 
}

function parseEscape(text){    
    text = text.split('+').join('%2B'); 
    text = text.split('&').join('%26'); 
    return text;
}

function sendTask(puid, sbjt, comment, sd, ed, nid, observers, taskList, on_home_screen){
    $$$('taskEditForm').style.display = 'none';
    var url = URLSTART + "/cgi-bin/mf.cgi";
    var params = {
                    "cmd": "add_note",
                    "param1": puid,
                    "subject": parseEscape(sbjt),
                    //"subject": sbjt,
                    "comment": parseEscape(parseCRLF(comment)),
                    "start_time": sd,
                    "end_time": ed,
                    "sid": SID,
                    "nid": nid,
                    "observers": observers,
                    "on_home_screen": on_home_screen,
                    "task_list_cnt": taskList.length,
                    "json": 1,
                    "rnd": Math.random(1)
                    };
    for(var i = 0; i < taskList.length; i++){
        params['task_list_nid_' + i] = taskList[i].nid;
        //params['task_list_sbjct_' + i] = taskList[i].sbjct;
        params['task_list_sbjct_' + i] = parseEscape(taskList[i].sbjct);
        params['task_list_comment_' + i] = parseEscape(parseCRLF(taskList[i].comment));
    }
    
    var tempParams = new Array();
    for(p in params){
        tempParams.push(p + '=' + params[p]);
    }    
    params = tempParams.join('&');
    AJAXPOSTLoad(url, params, function(responseText, status){
        try{
            //alert(responseText);
            var data = eval("(" + responseText + ")");            
            setTasks(data);
            updateUI(SHOW_DATE_TASKS, d2str(selectedDate));
            
        } catch(e){
            updateUI(SHOW_DATE_TASKS_ERROR, e);
            //var errorstr = responseText + '\nERROR:\n';for (i in e){errorstr += i + ': ' + e[i] + '\n';} alert(errorstr);
        };
    });

    //createTask(puid);
}



function getSysAjax2(){
    var url = URLSTART + "/cgi-bin/mf_sys.cgi?rnd=" + Math.random(1) + "&sid=" + SID;
        var temp_selectedDate = selectedDate;
        AJAXLoad(url, function(responseText, status){
            try{
                var data = eval("(" + responseText + ")");
                tmp_last_write_mid = data['last_write_mid'];
                if(tmp_last_write_mid > last_write_mid){
                    last_write_mid = tmp_last_write_mid;
                    getMessagesOverAjax();
                }
                updateUI(UPDATE_TIMER, d2str(temp_selectedDate));                
            } catch(e){
                alertError(e);
            }
        });
}


function getSysAjax(){
    var url = URLSTART + "/cgi-bin/mf_sys.cgi?rnd=" + Math.random(1) + "&sid=" + SID;
        AJAXLoad(url, function(responseText, status){
            try{
                var data = eval("(" + responseText + ")");
                tmp_last_write_mid = data['last_write_mid'];
                if(tmp_last_write_mid > last_write_mid){
                    last_write_mid = tmp_last_write_mid;
                    getMessagesOverAjax();
                }
            } catch(e){
                logError(e);
            }
            refresh_messages_tmr = setTimeout("getSysAjax()", sys_messages_tmr_interval);
        });

    }
    
function getMessagesOverAjax(){
    var url = URLSTART + "/cgi-bin/mf.cgi?cmd=view_messages&param2=" + last_recieved_message_id + "&sid=" + SID + "&json=1&rnd=" + Math.random(1);
    AJAXLoad(url, function(responseText, status){
        try{
            var data = eval("(" + responseText + ")");
            //alert(responseText);
            //showJSONMessages(data);
            var messages = data['messages'];
            var needUpdateUsers = 0;
            var needUpdateTasks = 0;
            for(var i = 0; i < messages.length; i++){
                var m = new Message(messages[i]);            
                if(m.sys > 0){
                    if(m.message.indexOf('users_changed') > -1){
                        needUpdateUsers = 1;
                    } else if(m.message.indexOf('tasks_changed') > -1){
                        needUpdateTasks = 1;
                    }            
                }
            }
            if(needUpdateTasks || needUpdateUsers){
                engineUpdateNotesAndUsersOnBack2(needUpdateTasks, needUpdateUsers);                        
            }
        } catch(e){
            alertError(e);
        }
    });
}    


function engineShowTasks(){
    var url = URLSTART + "/cgi-bin/mf.cgi?cmd=get_notes&sid=" + SID + "&rnd=" + Math.random(1);
    var temp_selectedDate = selectedDate;
    //prompt(temp_selectedDate, url);
    AJAXLoad(url, function(responseText, status){
        try{           
            var data = eval("(" + responseText + ")");
            setTasks(data);
            updateUI(SHOW_DATE_TASKS, d2str(temp_selectedDate));
        } catch(e){
            updateUI(SHOW_DATE_TASKS_ERROR, e);
        }
    });
}


function engineUpdateNotesAndUsersOnBack2(needUpdateTasks, needUpdateUsers){
    var url = URLSTART + "/cgi-bin/mf.cgi?cmd=update_notes_and_users&param1=" + needUpdateTasks + "&param2=" + needUpdateUsers + "&sid=" + SID + "&rnd=" + Math.random(1);
    var temp_selectedDate = selectedDate;
    //prompt(temp_selectedDate, url);
    AJAXLoad(url, function(responseText, status){
        try{           
            //alert(responseText);
            var data = eval("(" + responseText + ")");
            var tasks = data['tasks'];
            if(tasks && tasks.length){
                setTasks(data);
            }
            var users = data['users'];
            if(users){
                setUpUsers(data); 
            }
            updateUI(GET_TASKS_ON_BACK, d2str(temp_selectedDate));
            
            
        
        } catch(e){
            alertError(e);
            updateUI(GET_TASKS_ON_BACK_ERROR, e);
        }
    });
}


function engineUpdateNotesAndUsers(){
    var url = URLSTART + "/cgi-bin/mf.cgi?cmd=update_notes_and_users&param1=1&param2=1&sid=" + SID + "&rnd=" + Math.random(1);
    var temp_selectedDate = selectedDate;
    //prompt(temp_selectedDate, url);
    AJAXLoad(url, function(responseText, status){
        try{           
            var data = eval("(" + responseText + ")");
            setUpUsers(data); 
            setTasks(data);
            updateUI(UPDATE_DATA, d2str(temp_selectedDate));
        } catch(e){
            updateUI(UPDATE_DATA_ERROR, e);
        }
    });
}


function updateUsers(){
    var url = URLSTART + '/cgi-bin/mf.cgi?cmd=get_user_users&sid=' + SID + '&rnd=' + Math.random(1);
    //prompt('', url);
    AJAXLoad(url, function(responseText, status){
        try{
            var data = eval("(" + responseText + ")");
            setUpUsers(data);   
        } catch(e){}
    });
}

function engineGetNewPasswordCode(id){
    try{
        var login_url = URLSTART + '/cgi-bin/mf_widget.cgi?cmd=start_register&rnd=' + Math.random(1);
        AJAXLoad(login_url, function(responseText, status){
            try{
                var data = eval("(" + responseText + ")");                
                updateUI(NEW_PASSWORD_CODE, data);
                
            } catch(e){
                logError(e);
                updateUI(NEW_PASSWORD_CODE_ERROR);
            }
        });
    } catch(e){
        logError(e);
    }    
}


function engineGetRegisterCode(id){
    try{
        var login_url = URLSTART + '/cgi-bin/mf_widget.cgi?cmd=start_register&rnd=' + Math.random(1);
        AJAXLoad(login_url, function(responseText, status){
            try{
                var data = eval("(" + responseText + ")");                
                updateUI(REGISTER_NEW_USER, data);
                
            } catch(e){
                logError(e);
                updateUI(LOGIN_ERROR);
            }
        });
    } catch(e){
        logError(e);
    }    
}


function engineChangeUserParams(des_user_name, user_email){
    try{
        var url = URLSTART + '/cgi-bin/mf_widget.cgi?cmd=change_params&rnd=' + Math.random(1);
        url += '&email=' + user_email;
        url += '&des_name=' + des_user_name;
        url += '&sid=' + SID;
        
        AJAXLoad(url, function(responseText, status){
            try{
                var data = eval("(" + responseText + ")");                
                stopLodingAnim();    
                if(data['error']){
                    if(data['error'] == -17){
                        alert(getLabel('wrongcharindesname'));
                    }
                    if(data['error'] == -18){
                        alert(getLabel('wrongemail'));          
                    }
                } else {
                    alert(getLabel('userparamssaved'));
                    setUpUser(data);
                    showUserSettings();                                    
                }
            } catch(e){
                logError(e);
            }
        });        
    } catch(e){
    
    }
    
}

function engineChangeUserPassword(oldpassword, newpassword, confirmnewpassword, user_code, code){
    try{
        var url = URLSTART + '/cgi-bin/mf_widget.cgi?cmd=change_passwd&rnd=' + Math.random(1);
        url += '&oldpassword=' + oldpassword;
        url += '&newpassword=' + newpassword;
        url += '&confirmnewpassword=' + confirmnewpassword;
        url += '&user_code=' + user_code;
        url += '&code=' + code;
        url += '&sid=' + SID;
        AJAXLoad(url, function(responseText, status){
            try{
                var data = eval("(" + responseText + ")");                
                stopLodingAnim();    
                //alert(responseText);
                if(data['code']){
                    updateCapchaCode('userPasswordFormCode', 'userPasswordFormCodeImg', data);
                    setValue('userPasswordFormUserCode', '');
                    
                    if(data['error'] == -5){
                        alert(getLabel('wrongusercode'));
                    } else if(data['error'] == -11){ 
                        alert(getLabel('wrongpassword'));
                    } else if(data['error'] == -13){
                        alert(getLabel('passwordsnotequal'));
                    }             
                                
                    
                    
                } else {
                    alert(getLabel('userpasswordchanged'));
                    showUserSettings();                                    
                    
                }
                
            } catch(e){
                logError(e);
            }
        });
    } catch(e){
    
    }
}

function engineRegisterUser(login, password, des_user_name, email, user_code, code){
    try{
        var url = URLSTART + '/cgi-bin/mf_widget.cgi?cmd=register_user&rnd=' + Math.random(1);
        url += '&login=' + login;
        url += '&password=' + password;
        url += '&des_user_name=' + des_user_name;
        url += '&email=' + email;
        url += '&user_code=' + user_code;
        url += '&imei=' + IMEI;
        url += '&code=' + code;

        AJAXLoad(url, function(responseText, status){
            try{
                var data = eval("(" + responseText + ")");                
                if(data['result'] != '1'){
                    if(data['error'] == -11){
                        alert(getLabel('usernamealreadyexists'));
                    } else if(data['error'] == -5){                                      
                        alert(getLabel('wrongusercode'));
                    }
                    updateUI(REGISTER_ERROR, data);
                } else {
                    updateUI(REGISTER_USER, data);
                }
            } catch(e){
                logError(e);
                updateUI(REGISTER_ERROR);
            }
        });
    } catch(e){
        logError(e);
    }    
}


function engineGetCode(inp_id, img_id){
    try{
        var login_url = URLSTART + '/cgi-bin/mf_widget.cgi?cmd=start_register&rnd=' + Math.random(1);
        AJAXLoad(login_url, function(responseText, status){
            try{
                var data = eval("(" + responseText + ")");                                
                updateCapchaCode(inp_id, img_id, data);
                
            } catch(e){
                updateCapchaCode(inp_id, img_id, '', e);                
            }
        });
    } catch(e){
        updateCapchaCode(inp_id, img_id, '', e);                
    }    
}

function engineFindUser(add_user_name){
    var url = URLSTART + "/cgi-bin/mf.cgi?cmd=find_user&add_user_name=" + add_user_name + "&sid=" + SID + "&rnd=" + Math.random(1);
    AJAXLoad(url, function(responseText, status){
        try{
            var data = eval("(" + responseText + ")");          
            updateUI(FIND_USER, data);
        } catch(e){
            updateUI(FIND_USER_ERROR, e);
        }
    });
}

function engineAddUser(add_user_uid, can_add_note, can_send_message){
    var url = URLSTART + '/cgi-bin/mf.cgi?cmd=add_user&add_user_uid=' + add_user_uid + '&can_add_note=' + can_add_note + '&can_send_message=' + can_send_message + '&sid=' + SID + '&rnd=' + Math.random(1);
    AJAXLoad(url, function(responseText, status){
        try{
            var data = eval("(" + responseText + ")");
            updateUI(AUTH_USER_REQ, data);
        } catch(e){
            updateUI(AUTH_USER_REQ_ERROR, e);
        }
    });
}

function engineAcceptUser(puid){
    var url = URLSTART + "/cgi-bin/mf.cgi?cmd=accept_user&param1=" + puid + "&sid=" + SID + "&rnd=" + Math.random(1);
    AJAXLoad(url, function(responseText, status){
        try{
            var data = eval("(" + responseText + ")");
            updateUI(ACCEPT_USER, data);
        } catch(e){
            updateUI(ACCEPT_USER_ERROR, e);
        }
    });
}


function engineDeclineUser(puid){
    var url = URLSTART + "/cgi-bin/mf.cgi?cmd=decline_user&param1=" + puid + "&sid=" + SID + "&rnd=" + Math.random(1);
    AJAXLoad(url, function(responseText, status){
        try{
            var data = eval("(" + responseText + ")");
            updateUI(DECLINE_USER, data);
        } catch(e){
            updateUI(DECLINE_USER_ERROR, e);
        }
    });
}

function engineHideDeclineUser(puid){
    var url = URLSTART + "/cgi-bin/mf.cgi?cmd=hide_decline_user&param1=" + puid + "&sid=" + SID + "&rnd=" + Math.random(1);
    AJAXLoad(url, function(responseText, status){
        try{
            var data = eval("(" + responseText + ")");
            updateUI(DECLINE_USER, data);
        } catch(e){
            updateUI(DECLINE_USER_ERROR, e);
        }
    });
}



function engineAcceptUser2(add_user_uid, can_add_note){        
    var can_send_message = 1;
    var url = URLSTART + '/cgi-bin/mf.cgi?cmd=add_user&add_user_uid=' + add_user_uid + '&can_add_note=' + can_add_note + '&can_send_message=' + can_send_message + '&sid=' + SID + '&rnd=' + Math.random(1);
    AJAXLoad(url, function(responseText, status){
        try{
            var data = eval("(" + responseText + ")");
            updateUI(ACCEPT_USER2, data);
        } catch(e){
            updateUI(ACCEPT_USER_ERROR2, e);
        }
    });
}

            
function engineDeleteNote(nid){        
    var can_send_message = 1;
    var url = URLSTART + '/cgi-bin/mf.cgi?cmd=delete_note&nid=' + nid + '&sid=' + SID + '&rnd=' + Math.random(1);
    AJAXLoad(url, function(responseText, status){
        try{
            var data = eval("(" + responseText + ")");
            setTasks(data);
            updateUI(DELETE_TASK, data);
        } catch(e){
            updateUI(DELETE_TASK_ERROR, e);
        }
    });
}            
