function clearMessageTimer(){
    if (refresh_messages_tmr){
        window.clearTimeout(refresh_messages_tmr);
    }
}

function setMessageTimer(){
    refresh_messages_tmr = setTimeout("getSysAjax()", sys_messages_tmr_interval);
}

function showJSONMessages(data){
    var recieved_new_message = false;
    var needUpdateUsers = 0;
    var needUpdateTasks = 0;
    if(data){
        var messages = data['messages'];
        for(var i = 0; i < messages.length; i++){
            var m = new Message(messages[i]);
            if (last_recieved_message_id < m.mid && m.sys > 0){
                if(m.message.indexOf('users_changed') > -1){
                    needUpdateUsers = 1;
                } else if(m.message.indexOf('tasks_changed') > -1){
                    needUpdateTasks = 1;
                }

            } else { // ! sys
                all_messages.push(m);
                if (m.uid == current_user_id || m.puid == current_user_id){
                    recieved_new_message = true;
                }
                if(current_user_id != m.puid){
                    // var newMsgDivId = 'new_msg_from_' + m.puid + '_div';
                    //if($$$(newMsgDivId)){
                    //    $$$(newMsgDivId).innerHTML = '[mail]';
                    //}
                }
            }
            last_recieved_message_id = m.mid;
        }
    }
    var html = '';
    var last_showed_puid = 0;

    for(var i = 0; i < all_messages.length; i++){
        var m = all_messages[i];
        if (m.uid != current_user_id && m.puid != current_user_id || m.sys){
            continue;
        }
        html += '<div>';
        if(last_showed_puid != m.puid){
            html += '<div style="background-color: #FFFFFF; color: #7AB800; margin: 10px 3px 3px 3px; "><b>';
            html += users[m.puid]['name'];
            html += '</b></div>';
        }
        html += '<span style="padding: 3px 3px 5px 10px; ">' + m.message + '</span>';
        html += '<span style="background-color: #FFFFFF; color: #7AB800; "><small>' + m.create_time + '</small></span>';
        html += '</div>';
        last_showed_puid = m.puid;
    }
    //$$$("messagesFormMessagesDiv").innerHTML = html;

    if(needUpdateUsers){
        updateUsers();
    }
    if(needUpdateTasks){
        //alert('!');
        show_tasks();
    }

    if(recieved_new_message){
        scroll_down('messagesFormMessagesDiv');
    }
}



    function Message(data){
        this.sys = parseInt(data['sys']);
        this.puid = parseInt(data['puid']);
        this.uid = parseInt(data['uid']);
        this.mid = parseInt(data['mid']);
        this.message = data['message'];
        this.create_time = data['create_time'];

        return this;
    }